
// Make a namespace.
if (typeof directtune == 'undefined') {
  var directtune = {};
}

//Nur zur Sicherheit
if (typeof directtune.addList == 'undefined') {
  directtune.addList = [];
}

if (typeof(gMM) == "undefined")
  var gMM =  Components.classes["@songbirdnest.com/Songbird/Mediacore/Manager;1"].getService(Components.interfaces.sbIMediacoreManager);


directtune.PaneController = {

  /**
   * Called when the window finishes loading
   */
  onLoad: function() {
    this._prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    this._prefs = this._prefs.getBranch("extensions.directtune.");
	this._strings = document.getElementById("directtune-accesspane-strings");
	this._JSON = JSON.fromString(this._prefs.getCharPref("streams"));
	if (!this._JSON.streams){
	  this._JSON.streams=[];
	}
	this._streams=this._JSON.streams;
	for( var i = 0; i < this._streams.length; i++){
	  if (this._streams[i].pack){
	    this._streams[i]=this._getCurrentStream(this._streams[i]);
	  }
	}
	this._redraw();
  },
  

  /**
   * Called when the window is about to close
   */
  onUnLoad: function() {
    this._JSON.streams=this._streams;
	this._prefs.setCharPref("streams",JSON.toString(this._JSON,null));
  },
  
  _getViaURL:function(url){
    url=this._getCorrectURL(url);
	try {
	  var req = new XMLHttpRequest();
      req.open('GET', url, false); 
      req.send(null);
      if(req.status == 200){
        return req.responseText;
	  }else{
	    return "";
	  }
	} catch (e) {return "";}
  },
  _getCorrectURL:function(url){
    if (url.split("://").length<2){
	  url="http://"+url;
	}
	return url;
  },
  
  playURL:function(url,title){
    try {
      var uri = Components.classes["@mozilla.org/network/io-service;1"]
                      .getService(Components.interfaces.nsIIOService)
                      .newURI(url, null, null);
	  //Um Designprobleme zu vermeiden, doppelt abspielen
      gMM.sequencer.playURL(uri);
	  gMM.sequencer.playURL(uri);
	} catch (e) {alert(this._strings.getString("playback_fail")+"\n"+url+"\n\n"+e);}
	
	//Get the helper-label
    var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
    .getInterface(Components.interfaces.nsIWebNavigation)
    .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
    .rootTreeItem
    .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
    .getInterface(Components.interfaces.nsIDOMWindow);
    mainWindow.document.getElementById("directtune-title-info").childNodes[0].nodeValue=title;
	//Remove Rating "toolbar-entry"
	var ent = null;
	var ents = mainWindow.document.getElementsByTagName("sb-nowplaying-rating");
	var fptb = mainWindow.document.getElementById("faceplate-tool-bar");
	for (var i = 0; i<ents.length;i++)
	{
	  if (ents[i].parent=fptb) {ent=ents[i];}
	}
	if (ent != null)
      fptb.removeChild(ent);
  },
  
  playPURL:function(purl,title){
    //PURL ist fr einfaches M3U und PLS und erweitertes M3U geeignet.
    var url = null;
	
	try {
	  var playlist = this._getViaURL(purl);
	  
	  var plines = playlist.split("\n");
	  
	  var i = 0;
	  while ((plines[i][0]=="#")||(plines[i][0]==" ")||(plines[i]==""))
	  {
	    i++;
	  }
	  
	  url = plines[i];
	} catch (e) { alert (e);}
	
	if (url)
      this.playURL(url,title);
  },
  
  addEntry:function(){
	window.openDialog("chrome://directtune/content/addEntryDialog.xul", "",
    "chrome, dialog, modal, centerscreen, resizable=yes", this._streams, directtune.addList).focus();
	
	this._redraw();
  },
  
  newEntry:function(){
	window.openDialog("chrome://directtune/content/newEntryDialog.xul", "",
    "chrome, dialog, modal, centerscreen", this._streams).focus();
	
	this._redraw();
  },
  
  deleteEntry:function(index){
    var nstreams=[];
	for (var i = 0; i < this._streams.length; i++){
	  if (i != index)
	    nstreams.push(this._streams[i]);
	}
	this._streams=nstreams;
	this._redraw();
  },
  
  changeEntry:function(index){
    if (this._streams[index].purl){
	  var nurl=prompt(this._strings.getString("changeURL"),this._streams[index].purl);
	  if (nurl != null) {
        this._streams[index].purl=nurl;
	  }
	} else {
	  var nurl=prompt(this._strings.getString("changeURL"),this._streams[index].url);
	  if (nurl != null) {
        this._streams[index].url=nurl;
	  }
	}
	this._redraw();
  },
  
  _redraw:function(){
    //Neuanlegen der kompletten Liste
	var list = document.getElementById("directtune-list");
	while (list.childNodes.length>0){
	  list.removeChild(list.childNodes[0]);
	}
	
	if (this._streams.length == 0) {
	  var entry = list.appendChild(document.createElement("label"));
	  entry.className="directtune-empty-label";
	  entry.value=this._strings.getString("nothing");
	  return;
	}

	for (var i = 0; i < this._streams.length; i++){
	  var ent = list.appendChild(document.createElement("hbox"));
	  ent.className="directtune-list-entry";
	  var playbtn = ent.appendChild(document.createElement("button"));
	  playbtn.setAttribute("image","chrome://directtune/skin/play.png");
	  playbtn.setAttribute("label","");
	  if (this._streams[i].purl){
	    playbtn.setAttribute("oncommand","directtune.PaneController.playPURL(\""+this._streams[i].purl+"\",\""+this._streams[i].name+"\");");
	  } else {
	    playbtn.setAttribute("oncommand","directtune.PaneController.playURL(\""+this._streams[i].url+"\",\""+this._streams[i].name+"\");");
	  }
	  if (this._streams[i].image){
	    var lbox = ent.appendChild(document.createElement("vbox"));
	    lbox.appendChild(document.createElement("spacer")).setAttribute("flex","1");
	    var image = lbox.appendChild(document.createElement("image"));
		image.src=this._streams[i].image;
	    lbox.appendChild(document.createElement("spacer")).setAttribute("flex","1");
	  }
	  var lbox = ent.appendChild(document.createElement("vbox"));
	  lbox.appendChild(document.createElement("spacer")).setAttribute("flex","1");
	  lbox.appendChild(document.createElement("label")).appendChild(document.createTextNode(this._streams[i].name));
	  lbox.appendChild(document.createElement("spacer")).setAttribute("flex","1");
	  lbox.setAttribute("flex","1");
	  if (!this._streams[i].pack)
	  {
	    var changebtn = ent.appendChild(document.createElement("button"));
	    changebtn.setAttribute("oncommand","directtune.PaneController.changeEntry("+i+");");
	    changebtn.setAttribute("label",this._strings.getString("changeURL"));
	  }
	  var delbtn = ent.appendChild(document.createElement("button"));
	  delbtn.setAttribute("oncommand","directtune.PaneController.deleteEntry("+i+");");
	  delbtn.setAttribute("label",this._strings.getString("delete"));
	}
  },
  
  _getCurrentStream:function(item){
    var str = item;
	var arr = directtune.addList;
	for( var i = 0; i < arr.length; i++)
	{
	  if ((arr[i].name==item.name)&&(arr[i].pack==item.pack)){str = arr[i];}
	}
	return str;
  }
};

window.addEventListener("load", function(e) { directtune.PaneController.onLoad(e); }, false);
window.addEventListener("unload", function(e) { directtune.PaneController.onUnLoad(e); }, false);
