
// Make a namespace.
if (typeof directtune == 'undefined') {
  var directtune = {};
}

if (typeof Cc == 'undefined')
	var Cc = Components.classes;
if (typeof Ci == 'undefined')
	var Ci = Components.interfaces;
	
if (typeof SP == 'undefined')
	var SP = "http://songbirdnest.com/rdf/servicepane#";

const SC_NS_DT  = "http://songbirdnest.com/data/1.0#";	

if (typeof(gMM) == "undefined")
  var gMM =  Components.classes["@songbirdnest.com/Songbird/Mediacore/Manager;1"].getService(Components.interfaces.sbIMediacoreManager);

function findRadioNode(node, radioString) {
	if (node.isContainer && node.name != null &&
		((radioString && node.name == radioString)
		 || (node.getAttributeNS(SC_NS_DT, "radioFolder") == 1)))
	{
		node.setAttributeNS(SC_NS_DT, "radioFolder", 1);
		return node;
	}

	if (node.isContainer) {
		var children = node.childNodes;
		while (children.hasMoreElements()) {
			var child =
					children.getNext().QueryInterface(Ci.sbIServicePaneNode);
			var result = findRadioNode(child, radioString);
			if (result != null)
				return result;
		}
	}
	return null;
}

/**
 * UI controller that is loaded into the main player window
 */
directtune.Controller = {

  /**
   * Called when the window finishes loading
   */
  onLoad: function() {

    // initialization code
    this._initialized = true;
    this._strings = document.getElementById("directtune-strings");
    
    // Perform extra actions the first time the extension is run
    if (Application.prefs.get("extensions.directtune.firstrun").value) {
      Application.prefs.setValue("extensions.directtune.firstrun", false);
      this._firstRunSetup();
    }
    
  const Cc = Components.classes;
  const Ci = Components.interfaces;
  if (typeof(DTICON) == "undefined")
	const DTICON = "chrome://directtune/skin/pane-icon.png";
	
		// Create a service pane node for our chrome
		var SPS = Cc['@songbirdnest.com/servicepane/service;1'].
				getService(Ci.sbIServicePaneService);
		SPS.init();
		var BMS = Cc['@songbirdnest.com/servicepane/bookmarks;1'].
				getService(Ci.sbIBookmarks);
		
		// Walk nodes to see if a "Radio" folder already exists
		var radioFolder = findRadioNode(SPS.root);
		if (radioFolder == null) {
			radioFolder = BMS.addFolder(
					this._strings.getString("radioFolderLabel"));
			radioFolder.editable = false;
			radioFolder.setAttributeNS(SC_NS_DT, "radioFolder", 1);
		} else {
			// Relocalise the name on startup
			radioFolder.name = this._strings.getString("radioFolderLabel");
		}
		radioFolder.hidden = false;
	
		// Sort the radio folder node in the service pane
		radioFolder.setAttributeNS(SP, "Weight", 1);
		SPS.sortNode(radioFolder);

		// Bookmark the DirectTune chrome
		var bmNode = BMS.addBookmarkAt(
				"chrome://directtune/content/accesspane.xul", this._strings.getString("dtentry"),
				DTICON, radioFolder, null);
		if (bmNode) {
			bmNode.editable = true;
			bmNode.image = DTICON;
		} else {
			// bookmark already exists
			var node = SPS.getNodeForURL(
					"chrome://directtune/content/accesspane.xul");
			if (node.image != DTICON) {
				node.image = DTICON;
			}
		}
		
		directtuneUninstallObserver.register();
      
	  
	  var elem = document.getElementById("sb-player-title-label").parentNode.parentNode.appendChild(document.createElement("label"));
	  elem.id="directtune-title-info";
	  elem.className="faceplate-text sb-player-title-label";
	  elem.appendChild(document.createTextNode(""));
	  
	  gMM.addListener(this);
  },
  

  /**
   * Called when the window is about to close
   */
  onUnLoad: function() {
    this._initialized = false;
	gMM.removeListener(this);
  },
  
  
  /**
   * Perform extra setup the first time the extension is run
   */
  _firstRunSetup : function() {
  
  },
  
  //Listener
  onMediacoreEvent: function AlbumArt_onMediacoreEvent(aEvent) {
    switch(aEvent.type) {
      case Ci.sbIMediacoreEvent.STREAM_END:
      case Ci.sbIMediacoreEvent.STREAM_STOP:
      case Ci.sbIMediacoreEvent.TRACK_CHANGE:
        var dttextnode=document.getElementById("directtune-title-info").childNodes[0];
		if (dttextnode.nodeValue != "")
		{
		  dttextnode.nodeValue="";
		  //ratingen wieder ermglichen
		  document.getElementById("faceplate-tool-bar").appendChild(document.createElement("sb-nowplaying-rating"));
		  //workaround fr sequenzer-problem
		  gMM.sequencer.stop();
		  if (aEvent.type != Ci.sbIMediacoreEvent.STREAM_STOP)
	        gMM.sequencer.play();
		}
      break;
    }
  },
  onTrackIndexChange: function AlbumArt_onTrackIndexChange(aItem, aView, aIndex) { },
  onBeforeViewChange: function AlbumArt_onBeforeViewChange(aView) { },
  onViewChange: function AlbumArt_onViewChange(aView) { },
  onTrackChange: function AlbumArt_onTrackChange(aItem, aView, aIndex) { },
  
};

  var directtuneUninstallObserver = {
	_uninstall : false,
	_disable : false,
	_tabs : null,

	observe : function(subject, topic, data) {
		var radioString =
			directtune.Controller._strings.getString("radioFolderLabel");
		if (topic == "em-action-requested") {
			// Extension has been flagged to be uninstalled
			subject.QueryInterface(Ci.nsIUpdateItem);
			
			var SPS = Cc['@songbirdnest.com/servicepane/service;1'].
					getService(Ci.sbIServicePaneService);
			var radioNode = findRadioNode(SPS.root);
			var directtuneNode = SPS.getNodeForURL(
						"chrome://directtune/content/accesspane.xul");

			if (subject.id == "directtune@rsjtdrjgfuzkfg.com") {
				if (data == "item-uninstalled") {
					this._uninstall = true;
				} else if (data == "item-disabled") {
					this._disable = true;
					directtuneNode.hidden = true;
				} else if (data == "item-cancel-action") {
					if (this._uninstall)
						this._uninstall = false;
					if (this._disable)
						directtuneNode.hidden = false;
				}
			}
		} else if (topic == "quit-application-granted") {
			// We're shutting down, so check to see if we were flagged
			// for uninstall - if we were, then cleanup here
			if (this._uninstall) {
				// Things to cleanup:
				// Service pane node
				var SPS = Cc['@songbirdnest.com/servicepane/service;1'].
						getService(Ci.sbIServicePaneService);

				// Remove only the BirdTune node 
				var directtuneNode = SPS.getNodeForURL(
						"chrome://directtune/content/accesspane.xul");
				SPS.removeNode(directtuneNode);
				
				var librarySPS = Cc['@songbirdnest.com/servicepane/library;1']
					.getService(Ci.sbILibraryServicePaneService);

				// Remove the "Radio" node if it's empty
				// XXX stevel - in a loop due to bugs with multiple Radio
				// nodes having been created
				var radioFolder = findRadioNode(SPS.root);
				var enum = radioFolder.childNodes;
				while (enum.hasMoreElements()) {
					var node = enum.getNext();
					dump(node.name + "--" + node.url + "--" + node.id + "\n");
				}

				while (radioFolder != null && !radioFolder.firstChild) {
					SPS.removeNode(radioFolder);
					radioFolder = findRadioNode(SPS.root);
				}
			}
			this.unregister();
		}
	},

	register : function() {
		var observerService = Cc["@mozilla.org/observer-service;1"]
			.getService(Ci.nsIObserverService);
		observerService.addObserver(this, "em-action-requested", false);
		observerService.addObserver(this, "quit-application-granted", false);
	},

	unregister : function() {
		var observerService = Cc["@mozilla.org/observer-service;1"]
			.getService(Ci.nsIObserverService);
		observerService.removeObserver(this, "em-action-requested");
		observerService.removeObserver(this, "quit-application-granted");
	}
}

window.addEventListener("load", function(e) { directtune.Controller.onLoad(e); }, false);
window.addEventListener("unload", function(e) { directtune.Controller.onUnLoad(e); }, false);
